<template>
  <div class="py-10">
    <table class="border-collapse w-full">
      <thead>
        <tr>
          <th class="title-row">Id</th>
          <th class="title-row">Name</th>
          <th class="title-row">Email</th>
          <th class="title-row">Telephone</th>
          <th class="title-row">University</th>
          <th class="title-row">Office</th>
          <th class="title-row">Admission Date</th>
          <th class="title-row">Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="user in users"
          :key="user.id"
          class="content-section lg:flex-no-wrap"
        >
          <template>
            <td class="content-row">{{ user.id }}</td>
            <td class="content-row">{{ user.name }}</td>
            <td class="content-row">{{ user.email }}</td>
            <td class="content-row">{{ user.telephone }}</td>
            <td class="content-row">{{ user.university }}</td>
            <td class="content-row">{{ user.office }}</td>
            <td class="content-row">{{ user.date }}</td>
            <td class="content-row">
              <button id="delete-button" @click="onDelete(user.id)">
                <font-awesome-icon
                  class="fill-current text-red-700"
                  :icon="['fas', 'trash']"
                />
              </button>
              <button id="open-edit" @click.stop="handleClick(user)">
                <font-awesome-icon
                  class="fill-current text-green-700"
                  :icon="['fas', 'edit']"
                />
              </button>
            </td>
          </template>
        </tr>
      </tbody>
    </table>
    <Modal :editedUser="editedUser" />
  </div>
</template>

<script>
import Modal from "../components/EditUserModal";
export default {
  name: "UserTable",
  components: {
    Modal,
  },
  data() {
    return {
      editedUser: {
        id: "",
        name: "",
        email: "",
        telephone: "",
        office: "",
        university: "",
        date: "",
      },
    };
  },
  created() {
    this.$store.dispatch("users/loadUsers");
  },
  computed: {
    users() {
      return this.$store.getters["users/getUsers"];
    },
  },
  methods: {
    handleClick(user) {
      this.editedUser.id = user.id;
      this.editedUser.name = user.name;
      this.editedUser.email = user.email;
      this.editedUser.telephone = user.telephone;
      this.editedUser.university = user.university;
      this.editedUser.office = user.office;
      this.editedUser.date = user.date;
      this.$store.dispatch("users/toggleModal");
    },
    onDelete(id) {
      if (confirm("Confirma exclusão de estagiário?")) {
        this.$store.dispatch("users/deleteUser", id);
      } else {
        return;
      }
    },
  },
};
</script>

<style scoped>
.title-row {
  @apply p-3 font-bold bg-purple-800 text-white border border-gray-300 hidden lg:table-cell;
}
.content-row {
  @apply w-full p-3 lg:w-auto text-gray-800 text-center border border-b block lg:table-cell relative lg:static;
}
.content-section {
  @apply bg-white lg:hover:bg-gray-100 flex lg:table-row flex-row lg:flex-row flex-wrap mb-10 lg:mb-0;
}
</style>
